
#include <windows.h>  
#include <commctrl.h>
#include "getinfo.h"  



#if defined (WIN32)
	#define IS_WIN32 TRUE
#else
	#define IS_WIN32 FALSE
#endif

#define IS_NT      IS_WIN32 && (BOOL)(GetVersion() < 0x80000000)
#define IS_WIN32S  IS_WIN32 && (BOOL)(!(IS_NT) && (LOBYTE(LOWORD(GetVersion()))<4))
#define IS_WIN95   (BOOL)(!(IS_NT) && !(IS_WIN32S)) && IS_WIN32

HINSTANCE hInst;   // current instance

LPCTSTR lpszAppName = "MyApp";
LPCTSTR lpszTitle   = "TTM_GETTOOLINFO"; 


BOOL RegisterWin95( CONST WNDCLASS* lpwc );


int APIENTRY WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance,
                      LPTSTR lpCmdLine, int nCmdShow)
{
   MSG      msg;
   HWND     hWnd; 
   WNDCLASS wc;

   wc.style         = CS_HREDRAW | CS_VREDRAW;
   wc.lpfnWndProc   = (WNDPROC)WndProc;       
   wc.cbClsExtra    = 0;                      
   wc.cbWndExtra    = 0;                      
   wc.hInstance     = hInstance;              
   wc.hIcon         = LoadIcon (hInstance, lpszAppName); 
   wc.hCursor       = LoadCursor(NULL, IDC_ARROW);
   wc.hbrBackground = (HBRUSH)(COLOR_WINDOW+1);
   wc.lpszMenuName  = lpszAppName;              
   wc.lpszClassName = lpszAppName;              

   if ( IS_WIN95 )
   {
      if ( !RegisterWin95( &wc ) )
         return( FALSE );
   }
   else if ( !RegisterClass( &wc ) )
      return( FALSE );

   hInst = hInstance; 

   hWnd = CreateWindow( lpszAppName, 
                        lpszTitle,    
                        WS_OVERLAPPEDWINDOW, 
                        CW_USEDEFAULT, 0, 
                        CW_USEDEFAULT, 0,  
                        NULL,              
                        NULL,              
                        hInstance,         
                        NULL               
                      );

   if ( !hWnd ) 
      return( FALSE );

   ShowWindow( hWnd, nCmdShow ); 
   UpdateWindow( hWnd );         

   while( GetMessage( &msg, NULL, 0, 0) )   
   {
      TranslateMessage( &msg ); 
      DispatchMessage( &msg );  
   }

   return( msg.wParam ); 
}


BOOL RegisterWin95( CONST WNDCLASS* lpwc )
{
   WNDCLASSEX wcex;

   wcex.style         = lpwc->style;
   wcex.lpfnWndProc   = lpwc->lpfnWndProc;
   wcex.cbClsExtra    = lpwc->cbClsExtra;
   wcex.cbWndExtra    = lpwc->cbWndExtra;
   wcex.hInstance     = lpwc->hInstance;
   wcex.hIcon         = lpwc->hIcon;
   wcex.hCursor       = lpwc->hCursor;
   wcex.hbrBackground = lpwc->hbrBackground;
   wcex.lpszMenuName  = lpwc->lpszMenuName;
   wcex.lpszClassName = lpwc->lpszClassName;

   // Added elements for Windows 95.
   //...............................
   wcex.cbSize = sizeof(WNDCLASSEX);
   wcex.hIconSm = LoadImage(wcex.hInstance, lpwc->lpszClassName, 
                            IMAGE_ICON, 16, 16,
                            LR_DEFAULTCOLOR );
			
   return RegisterClassEx( &wcex );
}

// Toolbar buttons. 
//.................
TBBUTTON tbButtons[] = 
{ 
    { STD_FILENEW,  IDM_NEW, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0L, 0}, 
    { STD_FILEOPEN, IDM_OPEN, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0L, 0}, 
    { STD_FILESAVE, IDM_SAVE, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0L, 0}, 
    { 0, 0, TBSTATE_ENABLED, TBSTYLE_SEP, 0, 0L, 0}, 
    { VIEW_LARGEICONS, IDM_LARGEICON, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0L, 0}, 
    { VIEW_SMALLICONS, IDM_SMALLICON, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0L, 0}, 
    { VIEW_LIST, IDM_LISTVIEW, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0L, 0}, 
    { VIEW_DETAILS, IDM_REPORTVIEW, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0, 0L, 0}, 
}; 


LRESULT CALLBACK WndProc( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
static HWND hToolWnd = NULL;
static HWND hToolTip = NULL;

   switch( uMsg )
   {
      case WM_CREATE :
              if ( !hToolWnd )
              {
  
                 // Initialize the common control library
                 // and create the status window and toolbar.
                 //..........................................
                 InitCommonControls();

                 hToolWnd = CreateToolbarEx( hWnd, 
                                             WS_CHILD | WS_BORDER | 
                                             WS_VISIBLE, 
                                             102, 
                                             11,
                                             (HINSTANCE)HINST_COMMCTRL, 
                                             IDB_STD_SMALL_COLOR, 
                                             tbButtons, 4,
                                             0, 0, 100, 30, sizeof(TBBUTTON) );

                 if ( hToolWnd )
                 {
                    TOOLINFO    ti;
                    TBADDBITMAP tb;
                    int index, stdidx;

                    // Add the system-defined view bitmaps.
                    //.....................................
                    tb.hInst = HINST_COMMCTRL;
                    tb.nID = IDB_VIEW_SMALL_COLOR;
                    stdidx = SendMessage(hToolWnd, TB_ADDBITMAP, 12, (LPARAM)&tb);

                    // Update the indices to the bitmaps.
                    //...................................
                    for (index = 4; index < 8; index++)
                       tbButtons[index].iBitmap += stdidx;

                    // Add the view buttons.
                    //......................
                    SendMessage(hToolWnd, TB_ADDBUTTONS, 4, (LONG) &tbButtons[4]);

                    // Create tool tip control.
                    //.........................
                    hToolTip = CreateWindowEx( 0,
                                               TOOLTIPS_CLASS, NULL, 
                                               TTS_ALWAYSTIP,
                                               CW_USEDEFAULT, 
                                               CW_USEDEFAULT, 
                                               CW_USEDEFAULT, 
                                               CW_USEDEFAULT,
                                               hWnd, NULL, 
                                               hInst, NULL );

                    // Add the tools to the tool tip control.
                    //.......................................
                    ti.cbSize = sizeof( TOOLINFO );
                    ti.hwnd   = hToolWnd;
                    ti.hinst  = hInst;
                    ti.uFlags = TTF_SUBCLASS;

                    for( index=0; index < 8; index++ )
                    {
                       if ( index == 3 )
                          continue;

                       SendMessage( hToolWnd, TB_GETITEMRECT, 
                                    index, (LPARAM)&ti.rect );

                       ti.uId      = tbButtons[index].idCommand;
                       ti.lpszText = (LPTSTR)tbButtons[index].idCommand;

                       SendMessage( hToolTip, TTM_ADDTOOL, 0, (LPARAM)&ti );
                    }

                    // Set the tool tip control as 
                    // part of the toolbar.
                    //............................
                    SendMessage( hToolWnd, TB_SETTOOLTIPS, 
                                 (WPARAM)hToolTip, 0 );
                 }
              }
              break;

      case WM_COMMAND :
              switch( LOWORD( wParam ) )
              {
                 case IDM_NEW :
                 case IDM_OPEN :
                 case IDM_SAVE :
                 case IDM_LARGEICON :
                 case IDM_SMALLICON :
                 case IDM_LISTVIEW :
                 case IDM_REPORTVIEW :
                        {
                           TOOLINFO ti;
                           char     szMsg[64], szTxt[32];
                         
                           ti.cbSize = sizeof( TOOLINFO );
                           ti.hwnd   = hToolWnd;
                           ti.uId    = LOWORD( wParam );
                           SendMessage( hToolTip, TTM_GETTOOLINFO, 0, (LPARAM)&ti );

                           LoadString( ti.hinst, (UINT)ti.lpszText, szTxt, sizeof( szTxt ) );
                           wsprintf( szMsg, 
                                     "Tip text: %s   rect: %d %d %d %d", 
                                     szTxt, 
                                     ti.rect.left, ti.rect.top,
                                     ti.rect.right, ti.rect.bottom );

                           MessageBox( hWnd, szMsg, lpszTitle, MB_OK | MB_ICONINFORMATION );
                        }
                        break;

                 case IDM_ABOUT :
                        DialogBox( hInst, "AboutBox", hWnd, (DLGPROC)About );
                        break;

                 case IDM_EXIT :
                        DestroyWindow( hWnd );
                        break;
              }
              break;
      
      case WM_DESTROY :
              PostQuitMessage(0);
              break;

      default :
            return( DefWindowProc( hWnd, uMsg, wParam, lParam ) );
   }

   return( 0L );
}


LRESULT CALLBACK About( HWND hDlg,           
                        UINT message,        
                        WPARAM wParam,       
                        LPARAM lParam)
{
   switch (message) 
   {
       case WM_INITDIALOG: 
               return (TRUE);

       case WM_COMMAND:                              
               if (   LOWORD(wParam) == IDOK         
                   || LOWORD(wParam) == IDCANCEL)    
               {
                       EndDialog(hDlg, TRUE);        
                       return (TRUE);
               }
               break;
   }

   return (FALSE); 
}
